=== debian/changelog ===
libical (2.0.0-4) unstable; urgency=medium

  * libical2-dev: Conflict with libical3-dev.

 -- Matthias Klose <doko@debian.org>  Sat, 09 Dec 2017 17:00:55 +0100

libical (2.0.0-3) unstable; urgency=medium

  * Ship libical2-dev with content ...

 -- Matthias Klose <doko@debian.org>  Sat, 09 Dec 2017 15:51:24 +0100

libical (2.0.0-2) unstable; urgency=medium

  * QA upload.
  * Rename libical-dev to libical2-dev. libical-dev is now provided by
    libical3-dev.
  * Ignore timezones test failure on armhf and i386 for now.

 -- Matthias Klose <doko@debian.org>  Fri, 08 Dec 2017 15:03:25 +0100

libical (2.0.0-1) unstable; urgency=medium

  * QA upload.
  * Set the maintainer to the Debian QA group. See #879395.
  * Bump the standards version.
  * Update homepage. Closes: #873555.
  * Make the build reproducible (Chris Lamb). Closes: #796360.

 -- Matthias Klose <doko@debian.org>  Tue, 07 Nov 2017 20:07:30 +0100

libical (2.0.0-0.5) unstable; urgency=medium

  * Non-maintainer upload.
  * Run debian/libical2.symbols through c++filt and tag all c++ symbols
  * Mark std::vector::_M_insert_aux as optional
  * Add std::vector::_M_emplace_back_aux and mark it as optional.
    (Closes: #825477)

 -- Andreas Henriksson <andreas@fatal.se>  Mon, 01 Aug 2016 13:04:19 +0200

libical (2.0.0-0.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Upload to unstable.

 -- Andreas Henriksson <andreas@fatal.se>  Tue, 10 May 2016 13:54:26 +0200

libical (2.0.0-0.3) experimental; urgency=medium

  * Non-maintainer upload.
  * Drop obsolete files in debian/:
    - debian/.svnignore
    - debian/libical1a.docs (see debian/docs)
    - debian/libical1a.install (see debian/libical2.install)
    - debian/libical1a.symbols (see debian/libical2.symbols)
    - debian/python-libical.install
  * Blind attempts at arm64,ppc64el,mips64el buildd/testsuite fails
    which aren't reproducible on porterboxes:
    - debian/rules: switch --parallel to --no-parallel.
      (note how icalrecur-r/icalrecur tests both output test.out)

 -- Andreas Henriksson <andreas@fatal.se>  Fri, 06 May 2016 05:29:33 +0200

libical (2.0.0-0.2) experimental; urgency=medium

  * Non-maintainer upload.
  * Add build-dependency on libicu-dev to enable RSCALE support.
    - also make libical-dev depend on libicu-dev
  * Cherry-pick patches from upstreams 2.0 git branch:
    - 0001-icallangbind.h-fix-typo-on-the-icallangbind_quote_as.patch
    - 0002-icalrecur.c-fix-compile-on-ARM.patch

 -- Andreas Henriksson <andreas@fatal.se>  Thu, 28 Apr 2016 20:14:56 +0200

libical (2.0.0-0.1) experimental; urgency=medium

  * Non-maintainer upload.
  * New upstream release
    - includes reproducible build fix (Closes: #796360)
  * Rename libical1a -> libical2 to match new so name. (Closes: #797003)
  * Drop libical-dbg and rely on automatic dbgsym.
    - add dbgsym-migration flags and dump dh build-dep version.
  * Bump Standards-Version to 3.9.8
  * Multi-archify the packages (Closes: #813017)
    Thanks to Matthias Klose for the original patch.

 -- Andreas Henriksson <andreas@fatal.se>  Tue, 19 Apr 2016 16:19:47 +0200

libical (1.0.1-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Import debian/watch as suggested by packages.qa.debian.org
  * New upstream release
    - includes commit 60ebe54f 'icaltime.c: fix typo' (Closes: #791438)
    - includes fixes to icaltimezone (Closes: #760430)
  * Drop both patches, now included upstream.
    - debian/patches/fix_timezone_crash.patch,
    - debian/patches/reproducible-generator.patch
  * Update debian/*docs
    - Don't ship now non-existant NEWS
    - Spell README as ReadMe.txt
    - Add THANKS and ReleaseNotes.txt
  * Update debian/libical1a.symbols

 -- Andreas Henriksson <andreas@fatal.se>  Wed, 19 Aug 2015 19:27:40 +0200
