=== debian/control ===
Source: libical
Section: libs
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: cmake, debhelper (>= 9.20151219~), tzdata, libicu-dev, libgirepository1.0-dev
Standards-Version: 4.1.2
Homepage: https://github.com/libical/libical

Package: libical2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libical2 (= ${binary:Version}), ${misc:Depends}, libicu-dev
Breaks: libical-dev (<< 2.0.0-2)
Replaces: libical-dev (<< 2.0.0-2)
Conflicts: libical3-dev
Description: iCalendar library implementation in C (development)
 libical is an open source implementation of the IETF's iCalendar calendaring
 and scheduling protocols (RFC 2445, 2446, and 2447). It parses iCal components
 and provides a C API for manipulating the component properties, parameters,
 and subcomponents.

Package: libical2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: tzdata, ${misc:Depends}, ${shlibs:Depends}
Description: iCalendar library implementation in C (runtime)
 libical is an open source implementation of the IETF's iCalendar calendaring
 and scheduling protocols (RFC 2445, 2446, and 2447). It parses iCal components
 and provides a C API for manipulating the component properties, parameters,
 and subcomponents.
 .
 This package contains the files necessary for running applications that use
 the libical library.
