=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake --no-parallel --list-missing \
		--dbgsym-migration='libical-dbg (<< 2~)'

ifneq (,$(filter $(DEB_HOST_ARCH), armhf i386))
override_dh_auto_test:
	-dh_auto_test
endif
