=== debian/watch ===
version=3
opts=dversionmangle=s/^1\.0$/1.0.0/ \
https://github.com/libical/libical/releases \
.*[^n]/(?:|v|version-|version|release-|r|REL_|rel-|libical(?:_|-))(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
